// 
// Bright Framework : Version 0.0.5
// (C) Sergiy Lavryk
// jagermesh@gmail.com
// 

(function (window) {

  window.br = window.br || {};

  window.br.isNumber = function(value) {
    return (
             !isNaN(parseFloat(value)) && 
             isFinite(value)
           );
  }

  window.br.isNull = function(value) {
    return (
             (value === undefined) || 
             (value === null) 
           );
  }

  window.br.isEmpty = function(value) {
    return ( 
             br.isNull(value) || 
             ((typeof value.length != 'undefined') && (value.length === 0)) // Array, String
           );
  }

  window.br.isArray = function (value) {
    return (
             !br.isNull(value) && 
             (Object.prototype.toString.call(value) === '[object Array]')
           );
  }

  window.br.isObject = function (value) {
    return (!br.isEmpty(value) && (typeof value === 'object'));
  }

  window.br.isBoolean = function (value) {
    return (typeof value === 'boolean');
  }

  window.br.isString = function (value) {
    return (typeof value === 'string');
  }

  window.br.isNumber = function (value) {
    return (typeof value === 'number');
  }

  window.br.isFunction = function (value) {
    return (typeof value === 'function');
  }

  window.br.toString = function (value) {
    if (br.isNull(value)) {
      return '';
    } else {
      return value.toString();
    }
  }

  window.br.split = function (value, delimiter) {
    if (br.isEmpty(value)) {
      return [];
    } else 
    if (br.isString(value)) {
      return value.split(delimiter);
    }
  }

  window.br.toInt = function(value) {
    if (br.isString(value)) {
      if (value.length > 0) {
        return parseInt(value, 10);
      }
    } else
    if (br.isNumber(value)) {
      return value;
    }
  };

  window.br.toReal = function(value) {
    if (br.isString(value)) {
      if (value.length > 0) {
        return parseFloat(value);
      }
    } else
    if (br.isNumber(value)) {
      return value;
    }
  };  

})(window);
